(define (domain logistics)

    (:requirements :strips :typing)

    (:types package place - object) ; package and place

    (:predicates ;todo: define predicates here
        (truckpos ?pos - place)
        (package ?package_id - package ?pos - place)
        (packagein ?package_id - package)
        (connected ?pos1 ?pos2 - place)
    )

    (:action drive
        :parameters (?from ?to - place)
        :precondition (and (truckpos ?from) (connected ?from ?to))
        :effect (
            and (not (truckpos ?from)) (truckpos ?to)
        )
    )

    (:action load
        :parameters (?package_id - package ?pos - place)
        :precondition (and
            (truckpos ?pos)
            (package ?package_id ?pos)
            (not(packagein ?package_id))
            )
        :effect (and 
            (not (package ?package_id ?pos))
            (packagein ?package_id))
    )

    (:action unload
        :parameters (?package_id - package ?pos - place)
        :precondition (and (truckpos ?pos) (packagein ?package_id))
        :effect (and 
            (package ?package_id ?pos)
            (not (packagein ?package_id)) 
        )
    )

)