;Header and description

(define (domain logistics)

;remove requirements that are not needed
(:requirements :strips :negative-preconditions :typing :action-costs)

(:types 
  	pkg loc
)

; (:types ;todo: enumerate types and their hierarchy here, e.g. car truck bus - vehicle
; )

; un-comment following line if constants are needed
(:constants truck - loc)

(:predicates ;todo: define predicates here
    (truckpos ?pos - loc)
    (package ?pkg_id - pkg ?pos - loc)
    (connected ?pos1 ?pos2 - loc)
)

(:functions (total-cost) - number)


;define actions here

(:action drive
    :parameters (?from ?to - loc)
    :precondition (and (truckpos ?from) (connected ?from ?to))
    :effect (
        and (not (truckpos ?from)) (truckpos ?to)
        (increase (total-cost) 1)
    )
)

(:action load
    :parameters (?pkg_id - pkg ?pos - loc)
    :precondition (and (truckpos ?pos) (package ?pkg_id ?pos))
    :effect (and (not (package ?pkg_id ?pos)) (package ?pkg_id truck))
)

(:action unload
    :parameters (?pkg_id - pkg ?pos - loc)
    :precondition (and (package ?pkg_id truck) (truckpos ?pos))
    :effect (and (not (package ?pkg_id truck)) (package ?pkg_id ?pos) )
)

)